pipeline {
    agent any
    stages {
        stage ('Build Backend'){
            steps {
                sh 'mvn clean package -DskipTests=true'
            }
        }
        stage ('Unit Tests'){
            steps {
                sh 'docker rm postgres-teste-unitario -f'
                sh 'docker-compose -f docker/bd/docker-compose.yml up -d'
                sh 'mvn test'
            }
        }
        stage ('Sonar Analysis'){
        
            environment {
                scannerHome = tool 'SONAR_SCANNER'
            }
            
            steps {
                withSonarQubeEnv('SONAR_LOCAL'){
					sh "${scannerHome}/bin/sonar-scanner -e -Dsonar.projectKey=TesteUnitarioApp -Dsonar.host.url=http://localhost:9000 -Dsonar.login=5ab1989dd8d491a578236e5713af5856b75ae01b -Dsonar.java.binaries=target -Dsonar.java.libraries=${env.HOME}/.m2/repository/org/projectlombok/lombok/**/*.jar -Dsonar.coverage.exclusions=**/.mvn/**,**/src/test/**,**/config/**,**TesteUnitarioAppApplication.java"
                }               
            }   
        }
        stage ('Quality Gate'){
            steps{
                sleep(10)
                timeout(time:1, unit: 'MINUTES'){
                    waitForQualityGate abortPipeline: true
                }
            }
        }
    }
    post {
        // If Maven was able to run the tests, even if some of the test
        // failed, record the test results and archive the jar file.
        success {
            junit skipMarkingBuildUnstable: true, testResults:  '**/target/surefire-reports/*.xml, '
            archiveArtifacts 'target/*.jar'
        }
    }
        
    
}
